#include "mbed.h"
#include "DebounceIn.h"

DigitalOut led3(PB_3);
DigitalOut ft(PB_4);
DigitalOut laser(PB_5);
DebounceIn sw1(D3,PullUp);
EventQueue queue;
Thread thr_queue;
Timeout flipper;

void sw1_pressed_on(void) {
    printf("Light on switch\n");
}

void sw1_pressed_off(void) {
    printf("Light off switch\n");
}

void sw1_to(void) {
    printf("Light off timeout\n");
}

void flip() {
    if (led3 == 1) {
        led3 = 0;
        queue.call(sw1_to);
        ft=0; 
    }
}

void sw1_pressed(void) {
    led3 = !led3;
    ft = !ft;
    laser=!laser;
//    flipper.attach(&flip, 2.0); // setup flipper to call flip after 2 seconds
    if (led3 == 0) {
        queue.call(sw1_pressed_off);
    }
    else if (led3 == 1) {
        queue.call(sw1_pressed_on);
    }
}

int main(void) {
    printf("App started...\n");
    thr_queue.start(
    callback(&queue,&EventQueue::dispatch_forever));
    sw1.fall(sw1_pressed);
}